#include "Master.h"
#include "Clock.h"

int main(void) {

  Master m = newMaster();
  Tick (m, 5);
  Reset(m);
  Clock c1 = newClock(m);
  Tick (m, 7);
  Sync (c1);
  Tick (m, 3);
  Clock c2 = newClock(m);
  Sync (c1);
  Reset (m);
  Tick (m, 5);
  Sync (c1);
  Tick (m, 3);
  freeClock (c1);
  freeClock (c2);
  freeMaster (m);
  return 0;
}
