#include "Subject.h"
#include "Observer.h"

int main(void) {

  Subject s1 = newSubject();
  Subject s2 = newSubject();
  Observer o = newObserver(s1,s2);
  update(s1,2);
  int r1 = val(o);
  update(s1,5);
  update(s2,7);
  int r2 = val(o);
  
  Observer p1 = detachfirst (s1);
  Observer p2 = detachfirst (s2);
  freeSubject(s1);
  freeSubject(s2);
  freeObserver (p1);

  /* p2-p1 holds, so previous instruction already freed the single observer
     freeObserver (p2);*/

  return (r1+r2); /*(should be 14*/
}
