Require Import VST.floyd.proofauto.
Require Import VST.floyd.linking.

Require Import MM_prog.
Require Import stdlib.

Definition mmlib_prog': Clight.program := 
  match link_progs stdlib.prog mm_prog with
    Errors.OK p => p
  | _ => stdlib.prog
  end.

Definition mmlib_prog := ltac:
  (let x := eval hnf in mmlib_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).