#include "surelyMalloc.h"
#include "Connectionpool.h"

typedef struct node *Node;

struct node {
  Connection cn;
  struct node * next;
};


struct pool {
  Node members;
  Database db;
};

Pool consPool (Database d) {
  Pool p = (Pool)surely_malloc(sizeof *p);
  p -> members = NULL;
  p -> db = d;
  return p;
}

Connection getConn (Pool p) {
  Connection c;
  Node n = p->members;
  if (!n) {
    return (consConn(p->db));
  } else {
    c = n->cn;
    Node m = n->next;
    free(n);
    p->members=m;
    return c;
  }
}

void freeConn (Pool p, Connection c) {
  Node n = (Node)surely_malloc(sizeof *n);
  n->cn = c;
  n->next = p->members;
  p->members = n;
  return;
}
