Require Export VST.floyd.proofauto.

Definition DBIndex:Type:= Z.

Record DatabaseAPD := {
  DB: DBIndex -> val -> mpred;
  DB_ptrnull: forall db s, DB db s |-- !!(is_pointer_or_null s) && DB db s
}.

(*Definition ConnTP:Type:= Z.

Definition Connection:Type := val * ConnTP.
*)

Record ConnectionAPD := {
  ConnTP:Type;
  Conn: (val * ConnTP) -> val -> mpred;
  NextConn: ConnTP -> globals -> mpred;
  Conn_isptr: forall C c, Conn C c |-- !!(isptr c);
  Conn_validpointer: forall C c, Conn C c |-- valid_pointer c
}.

Record PoolAPD := {
  Pool: val -> val -> mpred; 
  Pool_ptrnull: forall d p, Pool d p |-- !!(is_pointer_or_null p)
}.

Hint Resolve Conn_validpointer : valid_pointer.
