Require Import VST.floyd.proofauto.
Require Import VST.floyd.linking.
Require Import malloc.
Require Import mmap0.

Definition mm_prog': Clight.program := 
  match link_progs mmap0.prog malloc.prog with
    Errors.OK p => p
  | _ => mmap0.prog
  end.

Definition mm_prog := ltac:
  (let x := eval hnf in mm_prog' in
   let x := eval simpl in x in 
   let x := eval compute in x in 
       exact x).