#include "surelyMalloc.h"
/*#include "PointOBJ_I1.h"*/
/*#include "PointOBJ_Interface.h*/
#include "MkPoints_I1.h"

struct point_I1 {
  Methods mtable;
  int value;
};

int get_I1 (Point p) {
  return (((struct point_I1 *)p)->value);
}

void set_I1 (Point p, int i) {
  ((struct point_I1 *)p)->value = i;
  return;
}

struct bpoint_I1 {
  BMethods mtable;
  int value;
};

void bump_I1 (BPoint p) {
  ((struct bpoint_I1 *)p)->value++;
  return;
}

struct cpoint_I1 {
  CMethods mtable;
  int value;
  int color;
};

int getC_I1 (CPoint p) {
  return (((struct cpoint_I1 *)p)->color);
}

/*LATER
void destroy_I1 (Point p) {
  free(((struct point_I1 *)p)->mtable);
  free(p);
  }*/

Point makePoint_I1 (int i) {
  struct point_I1 *p = (struct point_I1 *)surely_malloc(sizeof *p);
  p -> value = i;
  Methods m = (Methods)surely_malloc(sizeof *m);
  m -> get = &get_I1;
  m -> set = &set_I1;
  p -> mtable = m;
  return ((Point)p);
}

BPoint makeBPoint_I1 (int i) {
  struct bpoint_I1 *p = (struct bpoint_I1 *)surely_malloc(sizeof *p);
  p -> value = i;
  BMethods m = (BMethods)surely_malloc(sizeof *m);
  m -> get = &get_I1;
  m -> set = &set_I1;
  m -> bump = &bump_I1;
  p -> mtable = m;
  return ((BPoint)p);
}

CPoint makeCPoint_I1 (int i, int c) {
  struct cpoint_I1 *p = (struct cpoint_I1 *)surely_malloc(sizeof *p);
  p -> value = i;
  p -> color = c;
  CMethods m = (CMethods)surely_malloc(sizeof *m);
  m -> get = &get_I1;
  m -> set = &set_I1;
  m -> bump = &bump_I1;
  m -> getC = &getC_I1;
  p -> mtable = m;
  return ((CPoint)p);
}
