#include "surelyMalloc.h"
#include "MkPoints_I3.h"

struct point_I3 {
  Methods mtable;
  int value;
};

int get_I3 (Point p) {
  return (((struct point_I3 *)p)->value);
}

void set_I3 (Point p, int i) {
  ((struct point_I3 *)p)->value = i;
  return;
}

struct bpoint_I3 {
  BMethods mtable;
  int value;
};

void bump_I3 (BPoint p) {
  set_I3 ((Point)p, get_I3((Point)p) + 1);
  return;
}

struct cpoint_I3 {
  CMethods mtable;
  int value;
  int color;
};

int getC_I3 (CPoint p) {
  return (((struct cpoint_I3 *)p)->color);
}

/*LATER
void destroy_I3 (Point p) {
  free(((struct point_I3 *)p)->mtable);
  free(p);
  }*/

Point makePoint_I3 (int i) {
  struct point_I3 *p = (struct point_I3 *)surely_malloc(sizeof *p);
  p -> value = i;
  Methods m = (Methods)surely_malloc(sizeof *m);
  m -> get = &get_I3;
  m -> set = &set_I3;
  p -> mtable = m;
  return ((Point)p);
}

BPoint makeBPoint_I3 (int i) {
  struct bpoint_I3 *p = (struct bpoint_I3 *)surely_malloc(sizeof *p);
  p -> value = i;
  BMethods m = (BMethods)surely_malloc(sizeof *m);
  m -> get = &get_I3;
  m -> set = &set_I3;
  m -> bump = &bump_I3;
  p -> mtable = m;
  return ((BPoint)p);
}

CPoint makeCPoint_I3 (int i, int c) {
  struct cpoint_I3 *p = (struct cpoint_I3 *)surely_malloc(sizeof *p);
  p -> value = i;
  p -> color = c;
  CMethods m = (CMethods)surely_malloc(sizeof *m);
  m -> get = &get_I3;
  m -> set = &set_I3;
  m -> bump = &bump_I3;
  m -> getC = &getC_I3;
  p -> mtable = m;
  return ((CPoint)p);
}
