#include "SimpleClient.h"
#include "MkPoints_I1.h"
#include "MkPoints_I2.h"
#include "MkPoints_I3.h"
#include "Wrapper.h"

int test3(){
  Point p1 = makePoint_I1(3);
  CPoint cp1 = makeCPoint_I3(4, 2);

  int i1 = GET(p1);
  int i2 = GET((Point)cp1);
  BUMP((BPoint)cp1);
  SET((Point)cp1,5);
  int c = GETC(cp1);

  return (i1+i2+c); /*should be 9*/
}

#include <stdio.h> 
#include "PointList.h"

int test4(){
  Lst l = NULL;
  BPoint bp = makeBPoint_I3(1); l = insert (l,(Point)bp);
  CPoint cp = makeCPoint_I2(2,3); l = insert (l,(Point)cp);
  map_bump (l);
  int a1 = GET((Point)bp); /*2*/
  int a2 = GET((Point)cp); /*3*/
  
  Point p1 = makePoint_I1(3); l=insert (l,p1);
  map_set (l,42);
  
  Point p2 = makePoint_I2(4); l=insert (l,p2);

  return (sum(l)); /* 4 + 3*42 = 130 */
}
