#include "surelyMalloc.h"
#include "Observer.h"
#include "Subject.h"

#include "Subject_rep.h"

Subject newSubject () {
  Subject s = (Subject)surely_malloc(sizeof *s);
  s -> obs = NULL;
  s -> value = 0;
  s -> fl = NULL;
  return s;
}

void registr (Subject s, Observer o) {
  Node nd;
  if (s->fl) {
    nd = s->fl;
    s->fl = s->fl -> next;
  } else { 
    nd = (Node)surely_malloc(sizeof *nd); 
  }
  nd -> obs = o;
  nd -> next = s->obs;
  s -> obs = nd;
  notify(o);
};

void update (Subject s, int n) {
  s->value = n;
  Node nd = s -> obs;
  while (nd) {
    notify(nd->obs);
    nd = nd -> next;
  }
};

int get (Subject s) {
  return (s->value);
}; 

Observer detachfirst(Subject s) {  
  Node nd = s -> obs;
  if (!nd) { return NULL; }
  Observer o = nd -> obs;
  s -> obs = nd -> next;
  nd -> next = s->fl;
  s->fl = nd;
  return o;
}

int freeSubject(Subject s) {
  if (s->obs) { return 1; }
  Node n = s -> fl;
  while (n) {
    Node nd = n->next;
    free(n);
    n = nd;
  }
  free(s);
  return 0;
}
