#include "surelyMalloc.h"
#include "Wrapper.h"
#include "PointList.h"

struct list {
  Point elem;
  Lst next;
};

Lst insert (Lst l, Point p) {
  Lst node = (Lst)surely_malloc(sizeof *node);
  node -> elem = p;
  node -> next = l;
  return node;
}

void map_set (Lst l, int i) {
  Lst n = l;
  while (n) {
    SET(n->elem, i);
    n = n->next;
  }
}

void map_bump (Lst l) {
  Lst n = l;
  while (n) {
    BUMP((BPoint)(n->elem));
    n = n->next;
  }
}

int sum (Lst l) {
  int s = 0;
  Lst n = l;
  while (n) {
    s += GET(n->elem);
    n = n->next;
  }
  return s;
}

