#include "SimpleClient.h"
#include "MkPoints_I1.h"
#include "MkPoints_I2.h"

int test1(){
  Point p1 = makePoint_I1(3);
  BPoint bp1 = makeBPoint_I1(4);
  Methods p1_m = p1->mtable;
  int i1 = p1_m->get(p1);

  BMethods bp1_m = (BMethods)(bp1->mtable);
  int i2 = bp1_m->get((Point)bp1);

  bp1_m = (BMethods)(bp1->mtable);
  bp1_m->bump(bp1);

  bp1_m = (BMethods)(bp1->mtable);
  int i3 = bp1_m->get((Point)bp1);

  return (i1+i2+i3); /*should be 12*/
}

int test2(){
  Point p1 = makePoint_I2(3);
  BPoint bp1 = makeBPoint_I2(4);
  Methods p1_m = p1->mtable;
  int i1 = p1_m->get((Point)p1);

  BMethods bp1_m = (BMethods)(bp1->mtable);
  int i2 = bp1_m->get((Point)bp1);

  bp1_m = (BMethods)(bp1->mtable);
  bp1_m->bump(bp1);

  bp1_m = (BMethods)(bp1->mtable);
  int i3 = bp1_m->get((Point)bp1);

  return (i1+i2+i3); /*should be 12*/
}

int test12(){
  Point p = makePoint_I1(3);
  BPoint bp = makeBPoint_I2(4);
  CPoint cp = makeCPoint_I2(5,2);
  int i1 = (p->mtable)->get(p);

  int i2 = ((BMethods)(bp->mtable))->get((Point)bp);

  ((BMethods)(bp->mtable))->bump(bp);

  int i3 = ((BMethods)(bp->mtable))->get((Point)bp);

  ((CMethods)(cp->mtable))->bump((BPoint)cp);

  int i4 = ((CMethods)(cp->mtable))->get((Point)cp);

  int i5 = ((CMethods)(cp->mtable))->getC(cp);

  return (i1+i2+i3+i4+i5); /*20*/
}
/*
int test12(){
  Point p = makePoint_I1(3);
  BPoint bp = makeBPoint_I2(4);
  CPoint cp = makeCPoint_I2(5,2);
  Methods p_m = p->mtable;
  int i1 = p_m->get(p);

  BMethods bp_m = (BMethods)(bp->mtable);
  int i2 = bp_m->get((Point)bp);

  bp_m = (BMethods)(bp->mtable);
  bp_m->bump(bp);

  bp_m = (BMethods)(bp->mtable);
  int i3 = bp_m->get((Point)bp);

  CMethods cp_m = (CMethods)(cp->mtable);
  cp_m->bump((BPoint)cp);

  cp_m = (CMethods)(cp->mtable);
  int i4 = cp_m->get((Point)cp);

  cp_m = (CMethods)(cp->mtable);
  int i5 = cp_m->getC(cp);

  return (i1+i2+i3+i4+i5); 20
}*/
