Require Import VST.floyd.proofauto.
Require Import ASI_malloc.

Section ASI_SimpleClient.
Variable M: MallocFreeAPD.

Definition test1_spec :=
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Definition test2_spec :=
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 12)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

(*Different return value 19 rather than 20 in main deelopment, due to change in color due to overriding of "set"*)
Definition test12_spec :=
  WITH gv:globals
  PRE []
  PROP () PARAMS () GLOBALS (gv) SEP (mem_mgr M gv)
  POST [ tint ]
  PROP () RETURN (Vint (Int.repr 19)) SEP (mem_mgr M gv; TT) (*objects left over as we don't have dealloc yet*).

Definition ASI_SimpleClient t1 t2 t12: funspecs:= [ (t1,test1_spec); (t2,test2_spec); (t12,test12_spec)].
End ASI_SimpleClient.