#include "surelyMalloc.h"
#include "MkPoints_I4.h"

struct point_I4 {
  Methods mtable;
  int value;
};

int get_I4 (Point p) {
  return (((struct point_I4 *)p)->value);
}

void set_I4 (Point p, int i) {
  ((struct point_I4 *)p)->value = i;
  return;
}

struct bpoint_I4 {
  BMethods mtable;
  int value;
};

void bump_I4 (BPoint p) {
  BMethods m = (BMethods)(p->mtable);
  int i = m->get((Point)p) + 1;
  m = (BMethods)(p->mtable);
  m->set((Point)p, i);
  return;
}

struct cpoint_I4 {
  CMethods mtable;
  int value;
  int color;
};

int getC_I4 (CPoint p) {
  return (((struct cpoint_I4 *)p)->color);
}

/*LATER
void destroy_I4 (Point p) {
  free(((struct point_I4 *)p)->mtable);
  free(p);
  }*/

Point makePoint_I4 (int i) {
  struct point_I4 *p = (struct point_I4 *)surely_malloc(sizeof *p);
  p -> value = i;
  Methods m = (Methods)surely_malloc(sizeof *m);
  m -> get = &get_I4;
  m -> set = &set_I4;
  p -> mtable = m;
  return ((Point)p);
}

BPoint makeBPoint_I4 (int i) {
  struct bpoint_I4 *p = (struct bpoint_I4 *)surely_malloc(sizeof *p);
  p -> value = i;
  BMethods m = (BMethods)surely_malloc(sizeof *m);
  m -> get = &get_I4;
  m -> set = &set_I4;
  m -> bump = &bump_I4;
  p -> mtable = m;
  return ((BPoint)p);
}

void set_blue_I4 (Point p, int i) {
  ((struct cpoint_I4 *)p)->value = i;
  ((struct cpoint_I4 *)p)->color = 1;
  return;
}

CPoint makeCPoint_I4 (int i, int c) {
  struct cpoint_I4 *p = (struct cpoint_I4 *)surely_malloc(sizeof *p);
  p -> value = i;
  p -> color = c;
  CMethods m = (CMethods)surely_malloc(sizeof *m);
  m -> get = &get_I4;
  m -> set = &set_blue_I4;
  m -> bump = &bump_I4;
  m -> getC = &getC_I4;
  p -> mtable = m;
  return ((CPoint)p);
}
